; Utility Module Version 1.1
; Copyright (C) 2011 saguruma
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.

;******************************************************************************
; fadein
;******************************************************************************
Util_fadein:
  ldx <currentActivity
  lda processCounters, x
  asl a
  asl a
  eor #$FF
  and #$30
  sta <work1

  lda REG_PPU_2
  lda #$3F
  sta REG_PPU_6
  lda #$00
  sta REG_PPU_6
  tay
.loop0:
  lda [address1_LSB], y
  sec
  sbc <work1
  bmi .setBlack
  sta REG_PPU_7
  iny
  cpy #$20
  bcc .loop0
  bcs .next
.setBlack:
  lda #$0F
  sta REG_PPU_7
  iny
  cpy #$20
  bcc .loop0
.next:
  ldx <currentActivity
  inc processCounters, x
  lda processCounters, x
  cmp #16
  bcc .continue
  lda #0
  sta processCounters, x
  inc activities, x
.continue:
  rts


;******************************************************************************
; fadeout
;******************************************************************************
Util_fadeout:
  ldx <currentActivity
  lda processCounters, x
  asl a
  asl a
  clc
  adc #$10
  and #$70
  sta <work1

  lda REG_PPU_2
  lda #$3F
  sta REG_PPU_6
  lda #$00
  sta REG_PPU_6
  tay
.loop0:
  lda [address1_LSB], y
  sec
  sbc <work1
  bmi .setBlack
  sta REG_PPU_7
  iny
  cpy #$20
  bcc .loop0
  bcs .next
.setBlack:
  lda #$0F
  sta REG_PPU_7
  iny
  cpy #$20
  bcc .loop0
.next:
  ldx <currentActivity
  inc processCounters, x
  lda processCounters, x
  cmp #16
  bcc .continue
  lda #0
  sta processCounters, x
  inc activities, x
.continue:
  rts


